---
title: Xamarin.Android warning XA0112
description: XA0112 warning code
ms.date: 05/10/2019
---
# Xamarin.Android warning XA0112

## Issue

Your project has `$(AndroidUseAapt2)` set to `True`. However, `aapt2`
was not installed in your android-sdk build-tools.

## Solution

If you want to use `aapt2` resource processing, you need to install the
appropriate build-tools.

`aapt` is part of the Android SDK and is used internally by
Xamarin.Android to process and compile resources into binary assets.
Learn more about `aapt` and Android resources from the [Android
documentation][aapt].

`aapt2` is version 2.0 of `aapt`. Learn more about `aapt2` from the
[Android documentation][aapt2].

[aapt]: https://developer.android.com/guide/topics/resources/accessing-resources.html
[aapt2]: https://developer.android.com/studio/command-line/aapt2
