### Build and deployment performance

The `SignAndroidPackage` target will no longer execute the command:

```
keytool -list -keystore $(AndroidSigningKeyStore) --storepass $(AndroidSigningStorePass) -v
```

This was originally done [as a convenience][show-sha1], but this
adds ~200ms to the execution time of the `SignAndroidPackage` target,
which is executed as part of the inner development loop and the
Apply Changes feature within the UI Designer.

Running `keytool -list` does *nothing* to benefit the development loop,
while the archive workflow within Visual Studio can show the same information.

[show-sha1]: https://xamarin.github.io/bugzilla-archives/13/13154/bug.html

If you still need to determine the Keystore Signature, please follow the steps
in the article [Finding your Keystore's Signature][keystore-sig].

[keystore-sig]: https://docs.microsoft.com/en-us/xamarin/android/deploy-test/signing/keystore-signature?tabs=windows
